Attribute VB_Name = "ISS"
'===============================================================================
'   LST 2 ISS CONVERTOR
'   FredJust
'   http://www.fredjust.com
'   http://fred.just.free.fr
'===============================================================================

'===============================================================================
'   RESTE A FAIRE
'   INSTALLATION DES POLLICES
'   INSTALLATION DES REG
'   GESTION DES GROUPES MULTIPLES
'===============================================================================

Option Explicit

'===============================================================================
'   CONSTANTES PROVENANT DU SOURCE DE SETUP1.EXE
'   TOUTES NE SONT PAS UTILISEES
'===============================================================================
'Setup information file macros
Public Const gstrAPPDEST$ = "$(AppPath)"
Public Const gstrWINDEST$ = "$(WinPath)"
Public Const gstrFONTDEST$ = "$(Font)"
Public Const gstrWINSYSDEST$ = "$(WinSysPath)"
Public Const gstrWINSYSDESTSYSFILE$ = "$(WinSysPathSysFile)"
Public Const gstrPROGRAMFILES$ = "$(ProgramFiles)"
Public Const gstrCOMMONFILES$ = "$(CommonFiles)"
Public Const gstrCOMMONFILESSYS$ = "$(CommonFilesSys)"
Public Const gstrDAODEST$ = "$(MSDAOPath)"

'INI File keys
Public Const gstrINI_FILES$ = "Setup1 Files"  'default section to install
Public Const gstrINI_SETUP$ = "Setup"
Public Const gstrINI_COLOR$ = "Color"
Public Const gstrINI_BOOT$ = "Bootstrap"
Public Const gstrINI_APPNAME$ = "Title"
Public Const gstrINI_CABS$ = "Cabs"
Public Const gstrINI_APPDIR$ = "DefaultDir"
Public Const gstrINI_APPEXE$ = "AppExe"
Public Const gstrINI_APPPATH$ = "AppPath"
Public Const gstrINI_FORCEUSEDEFDEST = "ForceUseDefDir"
Public Const gstrINI_CABNAME$ = "CabFile"
Public Const gsPRIVATE As String = "PrivateGroup"

'Share type macros for files
Public Const mstrPRIVATEFILE = vbNullString
Public Const mstrSHAREDFILE = "$(Shared)"

Public Const gsSTARTMENUKEY As String = "$(Start Menu)"
Public Const gsPROGMENUKEY As String = "$(Programs)"
Public Const gsPARENT As String = "Parent"


'Global Action Key constants
Public Const gstrKEY_PRIVATEFILE = "PrivateFile"
Public Const gstrKEY_TEMPFILE = "TempFile"
Public Const gstrKEY_SHAREDFILE = "SharedFile"
Public Const gstrKEY_SYSTEMFILE = "SystemFile"
Public Const gstrKEY_CREATEDIR = "CreateDir"
Public Const gstrKEY_SHELLLINK = "ShellLink"
Public Const gstrKEY_DLLSELFREGISTER = "DllSelfRegister"
Public Const gstrKEY_EXESELFREGISTER = "ExeSelfRegister"
Public Const gstrKEY_TLBREGISTER = "TLBRegister"
Public Const gstrKEY_REMOTEREGISTER = "RemoteRegister"
Public Const gstrKEY_REGKEY = "RegKey"
Public Const gstrKEY_REGVALUE = "RegValue"

'
' Icon Information
'
Public Const gsGROUP As String = "Group"
Public Const gsICON As String = "Icon"
Public Const gsTITLE As String = "Title"
Public Const gsICONGROUP As String = "IconGroups"

Public Const gstrINI_BOOTFILES$ = "Bootstrap Files"
Public Const gstrINI_BOOTSTRAP$ = "Bootstrap"


'These should remain uppercase
Public Const gsEXT_FONTTTF As String = "TTF"
Public Const gsEXT_FONTFON As String = "FON"

'setup information file registration macros
'These should remain uppercase
Public Const mstrDLLSELFREGISTER$ = "$(DLLSELFREGISTER)"
Public Const mstrEXESELFREGISTER$ = "$(EXESELFREGISTER)"
Public Const mstrTLBREGISTER$ = "$(TLBREGISTER)"
Public Const mstrREMOTEREGISTER$ = "$(REMOTE)"
Public Const mstrVBLREGISTER$ = "$(VBLREGISTER)"  ' Bug 5-8039

'===============================================================================
'   AUTRES VARIABLE
'===============================================================================

'Tableau pour le split
Dim Param

'Objet scripting
Global gFSO As FileSystemObject
Dim ISS As TextStream

'Nom de l'icone
Dim mstrIcon As String
'Titre de l'icone
Dim mstrTitle As String
'Icon Demarre en
Dim mstrStart As String

'Fichier LST source
Global gstrLSTfile As String
'Fichier ISS cible
Global gstrISSfile As String
'Fichier TXT des prefernces
Global gstrPrefFile As String
'On ajoute un fichier a la fin
Global gblnAddFile As Boolean
'Nom du fichier a ajouer
Global gstrFileToAdd As String

'Nom du Group programme 0 dans le LST
Dim mstrGroupName As String

'Repertoire support
Global gstrSupportPath As String

'Numero de version du logiciel ex: 1.0
Global gstrAppVersion As String

'Nom du fichier EXE final
Global gstrOutputBaseFilename As String
'Repertoire contenant cet EXE
Global gstrOutputDir As String

'On integre les fichier VB ?
Global gblnWriteVBfile As Boolean
'On install ADO ?
Dim mblnADO As Boolean


'===============================================================================
'
'===============================================================================
Public Sub Lst2Iss()
    Dim tempo As String
    Dim Ligne As String
    Dim Filename As String
    Dim i As Long

 On Error Resume Next
 
'===============================================================================
'   DEBUT
'===============================================================================

    
    Set ISS = gFSO.CreateTextFile(Form1.txtISS)
    
    gstrLSTfile = Form1.txtLST
    gstrISSfile = Form1.txtISS
    gstrSupportPath = IIf((Form1.chkAbsPath = vbChecked), Form1.txtPath, "")
    gstrOutputDir = Form1.txtOutputDir
    gstrOutputBaseFilename = ""
    
    mblnADO = False
    
    Kill gstrISSfile

'===============================================================================
'   ECRITURE DE LA SECTION SETUP
'===============================================================================

    ISS.WriteLine "; This script was created by Lst2Iss"
    ISS.WriteLine "; http://fred.just.free.fr"
    ISS.WriteLine "; http://go.to/fredjust"
    ISS.WriteLine ""
    ISS.WriteLine "[Setup]"
    
    'lecture du titre de l'application
    tempo = ReadIniFile(gstrLSTfile, gstrINI_SETUP$, gstrINI_APPNAME$, "")
    gstrOutputBaseFilename = tempo
    
    'ecriture du titre
    ISS.WriteLine "AppName=" & tempo
    'ecriture du titre avec version
    ISS.WriteLine "AppVerName=" & tempo & " " & gstrAppVersion
    'ecriture de la version
    ISS.WriteLine "AppVersion=" & gstrAppVersion
    
    'lecture du repertoire d'install
    tempo = ReadIniFile(gstrLSTfile, gstrINI_SETUP$, gstrINI_APPDIR$, "")
    'ecriture du repertoire d'install
    ISS.WriteLine "DefaultDirName=" & ISSpath(tempo)
    
    
    'lecture du nom du group
    mstrGroupName = ReadIniFile(gstrLSTfile, gsICONGROUP, "Group0", "")
    ISS.WriteLine "DefaultGroupName=" & mstrGroupName
    
    'Destination Final du fichier
    ISS.WriteLine "OutputDir=" & gstrOutputDir
    ISS.WriteLine "OutputBaseFilename=" & gstrOutputBaseFilename
    
    'ecriture de mes preferences
    'DU FICHIER EXTERNE
    ISS.Write gFSO.OpenTextFile(gstrPrefFile, ForReading).ReadAll
    
    
'===============================================================================
'   ECRITURE DE LA SECTION FILES
'===============================================================================
    
    ISS.WriteLine ""
    ISS.WriteLine ""
    ISS.WriteLine "[Files]"
    
    If gblnWriteVBfile Then
        'Ecriture des fichiers de la section Bootstrap Files
        ISS.WriteLine "; START VISUAL BASIC "
        i = 1
        Ligne = ReadIniFile(gstrLSTfile, gstrINI_BOOTFILES$, "File" & CStr(i), "")
        While Ligne <> ""
            Param = Split(Ligne, ",")
            Filename = Replace(Param(0), "@", "")
            tempo = "Source: " & gstrSupportPath & Filename & "; DestDir: " & ISSpath(Param(1)) & _
                "; Flags: restartreplace uninsneveruninstall " & ISSregister(Param(2)) & _
                IIf(Param(3) = "", "", "sharedfile ") & "; CopyMode: alwaysskipifsameorolder"
            ISS.WriteLine tempo
            i = i + 1
            Ligne = ReadIniFile(gstrLSTfile, gstrINI_BOOTFILES$, "File" & CStr(i), "")
        Wend
        ISS.WriteLine "; END VISUAL BASIC"
    End If
    
    'Fichier de la section Setup1 Files
    i = 1
    Ligne = ReadIniFile(gstrLSTfile, gstrINI_FILES$, "File" & CStr(i), "")
    While Ligne <> ""
        Param = Split(Ligne, ",")
        Filename = Replace(Param(0), "@", "")
        
        If Filename <> "MDAC_TYP.EXE" Then
            tempo = "Source: " & gstrSupportPath & Filename & "; DestDir: " & ISSpath(Param(1)) & _
                "; Flags: " & ISSregister(Param(2)) & _
                IIf(Param(3) = "", "", "sharedfile ") & "; CopyMode: " & IIf(Param(2) = "", "alwaysskipifsameorolder", "normal")
        Else
            mblnADO = True
            tempo = "Source: " & gstrSupportPath & "Mdac_typ.exe; DestDir: {tmp}; CopyMode: normal; Flags: deleteafterinstall"
        End If
        ISS.WriteLine tempo
        i = i + 1
        Ligne = ReadIniFile(gstrLSTfile, gstrINI_FILES$, "File" & CStr(i), "")
    Wend
    
'===============================================================================
'   ECRITURE DE LA SECTION ICONS
'===============================================================================
    ISS.WriteLine ""
    ISS.WriteLine "[Icons]"
    
    i = 1
    ReadIcon i
    
    While mstrIcon <> ""
        'ecriture du nom de l'icone
        tempo = "Name: {group}\" & mstrTitle & "; Filename: {app}\" & mstrIcon & _
            ";WorkingDir: " & ISSpath(mstrStart) & "; IconFilename: {app}\" & mstrIcon & "; IconIndex: 0"
        ISS.WriteLine tempo
        i = i + 1
        ReadIcon i
    Wend
    
    If mblnADO Then
        ISS.WriteLine ""
        ISS.WriteLine "[Run]"
        ISS.WriteLine "Filename: {tmp}\Mdac_typ.exe; WorkingDir: {tmp}; Parameters: /q"
    End If
    
'===============================================================================
'   ECRITURE DES OPTIONS SUPPLEMENTAIRES
'===============================================================================
    If gblnAddFile Then
        ISS.WriteLine ""
        ISS.Write gFSO.OpenTextFile(gstrFileToAdd, ForReading).ReadAll
    End If

    
'===============================================================================
'   FIN
'===============================================================================
    
    ISS.Close
End Sub

'==================================================================================
'   LIT LES PROPRIETE DE L'ICONE
'==================================================================================
Private Sub ReadIcon(ByVal IconNum As Long)
    mstrIcon = ReadIniFile(gstrLSTfile, mstrGroupName, "Icon" & CStr(IconNum), "")
    mstrTitle = ReadIniFile(gstrLSTfile, mstrGroupName, "Title" & CStr(IconNum), "")
    mstrStart = ReadIniFile(gstrLSTfile, mstrGroupName, "StartIn" & CStr(IconNum), "")
End Sub

'==================================================================================
'   PARAMETRE D'ENREGISTREMENT LST => ISS
'==================================================================================
Private Function ISSregister(ByVal LSTregister As String) As String
'Private Const mstrEXESELFREGISTER$ = "$(EXESELFREGISTER)"
'Private Const mstrREMOTEREGISTER$ = "$(REMOTE)"
'Private Const mstrVBLREGISTER$ = "$(VBLREGISTER)"

    Select Case UCase(LSTregister)
        Case mstrDLLSELFREGISTER$
            ISSregister = "regserver "
        Case mstrTLBREGISTER$
            ISSregister = "regtypelib "
        Case ""
            ISSregister = ""
    End Select
End Function

'===============================================================================
'   REPERTOIRE LST => ISS
'===============================================================================
Private Function ISSpath(ByVal LSTpath As String) As String

'pas encore d'equivalence
'Public Const gstrCOMMONFILESSYS$ = "$(CommonFilesSys)"

Dim tempo As String
    tempo = LSTpath
    
    tempo = Replace(tempo, gstrAPPDEST$, "{app}")
    tempo = Replace(tempo, gstrWINDEST$, "{win}")
    tempo = Replace(tempo, gstrFONTDEST$, "{fonts}")
    tempo = Replace(tempo, gstrWINSYSDEST$, "{sys}")
    tempo = Replace(tempo, gstrWINSYSDESTSYSFILE$, "{sys}")
    tempo = Replace(tempo, gstrPROGRAMFILES$, "{pf}")
    tempo = Replace(tempo, gstrCOMMONFILES$, "{cf}")
    tempo = Replace(tempo, gstrDAODEST$, "{dao}")
    'Tempo = Replace(Tempo, gstrCOMMONFILESSYS$, "{}")
    ISSpath = tempo
    
End Function





















