Attribute VB_Name = "Ini"
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Function ReadIniFile(ByVal FileIni As String, ByVal SectionName As String, ByVal KeyName As String, ByVal DefaultValue As String) As String
    Dim Ret As String, NC As Long
    
    'Create a buffer
    Ret = Space(512)
    'Retrieve the string
    NC = GetPrivateProfileString(SectionName, KeyName, DefaultValue, Ret, 512, FileIni)
    'NC is the number of characters copied to the buffer
    Ret = Left$(Ret, NC)
    'Show our string
    ReadIniFile = Ret
End Function


